<?php
/**
* geshiPlus2
* revised version of the Joomla Geshi plugin
* allows use of an alternate tag in Joomla content to allow geshi
* markup in content that will be loaded and saved by editors.
* version: 2.0
* Copyright 2008-2009 Hugo Jackson/Tora. All rights reserved.
* This is a derivative work. Portions are copyright:
*     Open Source Matters
* and
*     Fiji Web Design (www.fijiwebdesign.com)
* This work is licensed under the GNU/GPL license.
* This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );
jimport( 'joomla.event.plugin' );

/**
* Revised Code Highlighting Plugin
*
*/
class plgContentGeshiPlus2 extends JPlugin {

//  function plgContentGeshiPlus( &$subject ) {
//    parent::__construct( $subject );
  function plgContentGeshiPlus2( &$subject, $params ) {
		parent::__construct( $subject, $params );
    $this->_plugin =& JPluginHelper::getPlugin( 'content', 'geshiplus2' );
    $this->_params = new JParameter( $this->_plugin->params );
 }
 /*
	function plgContentBookMarks( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
*/

  function onPrepareContent( &$row, &$params, $page=0 ) {
    if( $this->_params->get( 'tag' ) ) {
      $start_tag = '{geshi';
      $end_tag = '{/geshi}';
    } else {
      $start_tag = '<pre';
      $end_tag = '</pre>';
    }

    $regex = "#".$start_tag." xml:\s*(.*?)>(.*?)".$end_tag."#s";

    $GLOBALS['_MAMBOT_GESHI_PARAMS'] =& $params;
    $GLOBALS['_MAMBOT_GESHI_PARAMS2'] =& $this->_params;

    // perform the replacement
    $row->text = preg_replace_callback( $regex, 'plgContentGeshiplus2::replacer', $row->text );

    return true;
  }

/**
* Replaces the matched tags an image
* @param array An array of matches (see preg_match_all)
* @return string
*/
  private static function replacer( &$matches ) {
    $params =& $GLOBALS['_MAMBOT_GESHI_PARAMS'];
    $params2 =& $GLOBALS['_MAMBOT_GESHI_PARAMS2'];

    jimport('geshi.geshi');
    jimport('domit.xml_saxy_shared');

    $args = SAXY_Parser_Base::parseAttributes( $matches[1] );
    $text = $matches[2];

    $lang = JArrayHelper::getValue( $args, 'lang', 'php' );
    $lines = JArrayHelper::getValue( $args, 'lines', 'false' );
    $initial = JArrayHelper::getValue( $args, 'initial', '1' );
    
    // -- Rep(Tora) --
//    $interval = JArrayHelper::getValue( $args, 'interval', 'default' );
//    $background = JArrayHelper::getValue( $args, 'background', '#fcfcfc' );
//    $foreground = JArrayHelper::getValue( $args, 'foreground', '#f0f0f0' );

    $def_interval = $params2->get( 'def_interval' );
    $def_backcolor = $params2->get( 'def_backcolor' );
    $def_forecolor = $params2->get( 'def_forecolor' );
    if(!isset($def_interval) || $def_interval==''){
	    $def_interval='1';
    }
    if(!isset($def_backcolor) || $def_backcolor==''){
	    $def_backcolor='#fcfcfc';
    }
    if(!isset($def_forecolor) || $def_forecolor==''){
	    $def_forecolor='#f0f0f0';
    }
    // -- Rep(Tora) --
    
    $interval = JArrayHelper::getValue( $args, 'interval', $def_interval );
    $background = JArrayHelper::getValue( $args, 'background', $def_backcolor );
    $foreground = JArrayHelper::getValue( $args, 'foreground', $def_forecolor );

	
    // -- Rep(Tora v1.1 2009.10.30) --
    $html_entities_match = array( '/&lt;/', '/&gt;/' , '/\t/' );
    $html_entities_replace = array( '<', '>','  ' );

    $text = preg_replace( $html_entities_match, $html_entities_replace, $text );

//    $html_entities_match = array( "|\<br \/\>|", "#<#", "#>#", "|&#39;|", '#&quot;#', '#&nbsp;#' );
//    $html_entities_replace = array( "\n", "&lt;", "&gt;", "'", '"', ' ');
//
//    $text = preg_replace( $html_entities_match, $html_entities_replace, $text );
//	
//    $text = str_replace('&lt;', '<', $text);
//    $text = str_replace('&gt;', '>', $text);
    // -- Rep(Tora v1.1) --
    
	//	 first & end retun value is cut.
	$pre_cut=$params2->get( 'cut_pre_return' );
	$pos_cut=$params2->get( 'cut_pos_return' );
	if(!isset($pre_cut) || is_null($pre_cut) || empty($pre_cut)){
		$pre_cut='false';
	}
	if(!isset($pos_cut) || is_null($pos_cut) || empty($pos_cut)){
		$pos_cut='false';
	}

    $pre_cut = JArrayHelper::getValue( $args, 'precut', $pre_cut );
    $pos_cut = JArrayHelper::getValue( $args, 'poscut', $pos_cut );
    $pos_all = JArrayHelper::getValue( $args, 'allcut', 'false'  );

	if(($pre_cut=='true' || $pos_all=='true' ) && ($npos=strpos($text,"\n"))!=false){
	    $text = substr($text,$npos+1); // first return
	}
	  
	if(($pos_cut=='true' || $pos_all=='true' )  && ($npos=strrpos($text,"\n"))!=false){
	    $text = substr($text,0, $npos-1); // end return
	}


//	// Replace 2 spaces with "&nbsp; " so non-tabbed code indents without making huge long lines.
//	$text = str_replace("  ", "&nbsp; ", $text);
//	// now Replace 2 spaces with " &nbsp;" to catch odd #s of spaces.
//	$text = str_replace("  ", " &nbsp;", $text);

	// Replace tabs with "&nbsp; &nbsp;" so tabbed code indents sorta right without making huge long lines.
	//$text = str_replace("\t", "&nbsp; &nbsp;", $text);
//    $text = str_replace( "\t", '  ', $text );

    $geshi = new GeSHi( $text, $lang );
    switch( $lines ) {
      case 'true':
        $geshi->enable_line_numbers( GESHI_NORMAL_LINE_NUMBERS );
        $geshi->set_line_style( 'background: '.$background.';', true );
        $geshi->start_line_numbers_at( $initial );
        break;
      case 'fancy':
        // -- Rep(Tora) --
	    // $geshi->enable_line_numbers( GESHI_FANCY_LINE_NUMBERS );
        if(isset($interval) && $interval!=''){
	        $geshi->enable_line_numbers( GESHI_FANCY_LINE_NUMBERS ,$interval);
        } else {
	        $geshi->enable_line_numbers( GESHI_FANCY_LINE_NUMBERS );
        }
        // -- Rep(Tora) --
        
        $geshi->set_line_style( 'background: '.$background.';', 'background: '.$foreground.';', true );
        $geshi->start_line_numbers_at( $initial );
        break;
      case 'false':
      default:
        break;
    }

	$htag_type=GESHI_HEADER_PRE;
	$header_tag=$params2->get( 'def_header_tag' );
	
	if(!isset($header_tag) || is_null($header_tag) || empty($header_tag)){
		$header_tag='pre';
	}
    // -- Rep(Tora v1.1) --
    $header_tag = JArrayHelper::getValue( $args, 'htag', $header_tag );
    // -- Rep(Tora v1.1) --

	switch($header_tag){
	case 'div':
		$htag_type=GESHI_HEADER_DIV;
		break;
	case 'valid':
		$htag_type=GESHI_HEADER_PRE_VALID;
		break;
	case 'table':
		$htag_type=GESHI_HEADER_PRE_TABLE;
		break;
	case 'none':
		$htag_type=GESHI_HEADER_NONE;
		break;
	default:
		break;
	}
    // -- Rep(Tora v1.1) --
	$geshi->enable_strict_mode(false);
    // -- Rep(Tora v1.1) --

	$geshi->set_header_type($htag_type);
    $text = $geshi->parse_code();

//    $text = str_replace('\n', '<br />', $text);

    return $text;
  }
}
